image: 
  name: lob-docker.jfrog.io/devtools/bash/prd:latest
  username: $ARTIFACTORY_USER
  password: $ARTIFACTORY_PASSWORD
clone:
  depth: 5
definitions:
  services:
    docker:
      memory: 3072
  steps:
  - step: &dind
      name: support dind
      services:
        - docker
      caches:
        - docker
  - step: &buildAndTest
      name: build and test
      script:
        - set_dockerrc.sh
        - set_npmrc.sh
        - installNodeDependencies.sh
        - dynamodb
        - prebuild_test.sh
        - buildNPMPack.sh
      services:
        - docker
      caches:
        - docker
pipelines:
  default:
    - step:
        <<: *buildAndTest
        name: Default pipe, build and test
  branches:
    integration:
      - step:
          <<: *buildAndTest
          name: Integration,  build and test
          artifacts:
            - "**/*.zip"
            - "*.zip"
      - step:
          <<: *dind
          name: Integration, deploy
          script:
            - set_dockerrc.sh
            - deploy.sh
      - step:
          <<: *dind
          name: Integration, postdeploy test
          script:
            - set_dockerrc.sh
            - postdeploy_test.sh
    staging:
      - step:
          <<: *dind
          name: Rev Version
          script:
            - set_dockerrc.sh
            - set_ssh.sh
            - rev_version.sh
      - step:
          <<: *buildAndTest
          name: Staging,  build and test
          artifacts:
            - "**/*.zip"
            - "*.zip"
      - step:
          <<: *dind
          name: Staging, deploy
          script:
            - set_dockerrc.sh
            - deploy.sh
            - promote.sh
      - step:
          <<: *dind
          name: Staging, postdeploy test
          script:
            - set_dockerrc.sh
            - postdeploy_test.sh
    production:
      - step:
          <<: *dind
          name: Production, promote
          script:
            - set_dockerrc.sh
            - promote.sh
      - step:
          <<: *dind
          name: Production, postdeploy test
          script:
            - set_dockerrc.sh
            - postdeploy_test.sh